<%
    Option Explicit
    '//TURN OFF WORD WRAPPING TO VIEW CODE CORRECTLY
%>
<!--#include file="sort_clsDataGrid.asp"-->
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">
<html>
<head>
<title>Data Grid Class Example &#187; Using Existing Database Connection With Paging and Styles</title>
<meta name="Author" content="ndelmedico @ pixel420.com" />
<meta http-equiv="content-type" content="text/html; charset=iso-8859-1" />
<style type="text/css">
    body {font-family: tahoma, verdana, arial, helvetica, sans-serif; font-size: 12px;}
    p {font-family: "Courier New", arial, helvetica, sans-serif; font-size: 12px;}
    .clsgrid {background-color: #EEEEEE; color: #333366; border-style: groove; border-width: 2px; border-color: #FFFFFF;}
    .clsheader {font-family: tahoma, verdana, arial, helvetica, sans-serif; font-size: 12px; font-weight: bold; background-color: #333366; color: #FFFFFF; border-style: groove; border-width: 2px; border-color: #FFFFFF;}
    .clsfooter {font-family: tahoma, verdana, arial, helvetica, sans-serif; font-size: 12px; font-weight: bold; background-color: #333366; color: #FFFFFF; border-style: groove; border-width: 2px; border-color: #FFFFFF;}
    .clsitem {font-family: verdana, arial, helvetica, sans-serif; font-size: 12px; background-color: #CCCCCC; color: #333366;}
    .clsitemalt {font-family: verdana, arial, helvetica, sans-serif; font-size: 12px; background-color: #EEEEEE; color: #333366;}
    a.clslink:link {text-decoration: none; color: #EEEEEE; background-color: transparent;}
    a.clslink:visited {text-decoration: none; color: #EEEEEE; background-color: transparent;}
    a.clslink:hover {text-decoration: underline; color: #FFFF00; background-color: transparent;}
</style>
</head>
<body>
<p>This is a duplicate of ex_paging.asp except it uses sort_clsDataGrid.asp which allows you to set column headers as "sort by" links. The .BoundColumn Method now takes 2 more arguments. True/False if the column is "sort by". And a string to specify a CSS class or an empty string for none. See code below for example. The sorting isn't in the other version because it doesn't work with stored procedures (unless you add a sort by param).<br /><a href="ex_dbconn_exists.asp">back to other examples</a></p>
<%
    Response.Write(vbCrLf & vbCrLf & "<p>Code Used for following DataGrid:<br />---------------------------------<br />Set objDataGrid = New clsDataGrid<br />Set objDataGrid.Connection = objConn<br />objDataGrid.Command = strQuery<br />objDataGrid.PageResults = True<br />objDataGrid.PageSize = 10<br />objDataGrid.CurrentRecord = intBegRec<br />Call objDataGrid.SetTableOptions(""100%"", 2, 2, 0)<br />objDataGrid.GridClassName = ""clsgrid""<br />")
    Response.Write("objDataGrid.HeaderClassName = ""clsheader""<br />objDataGrid.ItemClassName = ""clsitem""<br />objDataGrid.AltItemClassName = ""clsitemalt""<br />objDataGrid.FooterClassName = ""clsfooter""<br />objDataGrid.PagingLinkClass = ""clslink""<br />objDataGrid.AutoGenerateCols = False<br />Call objDataGrid.BoundColumn(""testID"", ""Character ID"", True, ""clslink"")<br />")
    Response.Write("Call objDataGrid.BoundColumn(""testCharacter"", ""Character Name"", True, ""clslink"")<br />Call objDataGrid.BoundColumn(""testFromWhat"", ""Book/Show"", True, ""clslink"")<br />Call objDataGrid.BoundColumn(""testDate"", ""Date Entered"", True, ""clslink"")<br />objDataGrid.Bind()<br />Set objDataGrid = Nothing</p>")

    '//Example Usage
    '//Uses an exisiting connection and a bunch (not all) of properties
    '//Styling is done by assigning CSS classes but inline styles can be used just as easy with the .Style propertie

    '//Declare Variables
    Dim objConn '//Connection object that the DataGrid will use
    Dim objDataGrid, strQuery, intBegRec

    openDB() '//Open a database connection [see subs at bottom of page]

    '//Since we're paging the records this time we need a var to grab the start record
    intBegRec = Request.Querystring("nxtrec")
    '//Make sure no one f'd with the querystring
    If IsNumeric(intBegRec) Then
        intBegRec = CInt(intBegRec)
    Else
        intBegRec = 0
    End If

    '//SQL Command that is passed to the Class
    strQuery = "Select testID, testCharacter, testFromWhat, testDate From tblTest"
    '//Create the DataGrid
    Set objDataGrid = New clsDataGrid
    Set objDataGrid.Connection = objConn
    objDataGrid.Command = strQuery
    objDataGrid.PageResults = True
    objDataGrid.PageSize = 10 '//You could set this from the qs as well
    objDataGrid.CurrentRecord = intBegRec '//Like this one is
    Call objDataGrid.SetTableOptions("100%", 2, 2, 0)
    objDataGrid.GridClassName = "clsgrid"
    objDataGrid.HeaderClassName = "clsheader"
    objDataGrid.ItemClassName = "clsitem"
    objDataGrid.AltItemClassName = "clsitemalt"
    objDataGrid.FooterClassName = "clsfooter"
    objDataGrid.PagingLinkClass = "clslink"
    objDataGrid.AutoGenerateCols = False
    Call objDataGrid.BoundColumn("testID", "Character ID", True, "clslink")
    Call objDataGrid.BoundColumn("testCharacter", "Character Name", True, "clslink")
    Call objDataGrid.BoundColumn("testFromWhat", "Book/Show", True, "clslink")
    Call objDataGrid.BoundColumn("testDate", "Date Entered", True, "clslink")
    objDataGrid.Bind()
    Set objDataGrid = Nothing

    closeDB() '//Close database connection

    '//Subs to open and close the DB connection
    Public Sub openDB()
        If Not IsObject(objConn) Then
            Set objConn = Server.CreateObject("ADODB.Connection")
            objConn.Open "Provider=Microsoft.Jet.OLEDB.4.0; Data Source=" & Server.MapPath("example_db.mdb") & "; User Id=; Password=;"
        End If
    End Sub

    Public Sub closeDB()
        If IsObject(objConn) Then
            objConn.Close
            Set objConn = Nothing
        End If
    End Sub
%>
</body>
</html>